codeforces Goodbye2018 C. New Year and the Permutation Concatenation 傻瓜解法找规律+打表

这是goodbye2018的D题,红包赛第一场的C题
是我打的第一场CF
不知道为什么每次一补到这一场我就要强调一遍这是我的第一场CF......
....
....
真矫情
不过还挺有仪式感的,嗯嗯~ o( ̄▽ ̄)o
看题吧
这题是肯定有公式的,不然这么乱七八糟的真的很难找规律,而且题目的名字就是permutation concatenation
这个题目真的很坏,只给了n=3时ans=9;n=4时ans=56;
其实如果知道了n=5时,ans=395,问题就迎刃而解了

我的方法跟官方题解的不一样,题解用的是分析next_permutation的操作原理,然后给这个题目推出了一个公式
但是对于我们这种,没法在短短十几分钟内把握整个题目全部操作的人,肯定很难一口气把公式给推出来
但是,我们可以打表
打表代码如下:

#include<bits/stdc++.h>
using namespace std;
//#define int long long
const int N = 1e8;
int a[N];
int b[N];
int ans, cnt,sum,n;
int32_t main(){
    while(scanf("%d",&n)==1&&n!=-1){
        ans = cnt = sum = 0;
        for (int i = 0; i < n; i++)
            a[i] = i+1;

        do
        {
            for (int i = 0; i < n; i++){
                 b[++cnt] = a[i];
            }
    } while (next_permutation(a,a+n));

    for (int i = 1; i<=cnt-n+1;i++){
        sum = 0;
        for (int j = i; j <i+n;j++)
            sum += b[j];
        if(sum==n*(n+1)/2)
            ans++;
    }

    cout << ans<<endl;
    }
    system("pause");
    return 0;
}

打表的时候有两个地方要提:
1.不用mod的话,我们开一个1e8的数组,最多可以显示到n=10的位置
再多就不行了
2.打表的结果:

现在来分析怎么得出一个菜鸟也能找出来的规律,而不是题解里的那种规律
n=1: ans=1;
n=2: ans=2;
n=3; ans=9=3!+3;
n=4; ans=56=4!+32;
n=5: ans=395=5!+275;

首先,为什么提出来一个i的阶乘?
因为题目是将1~n的数进行全排列,那么首先全排列的种类就是n!的阶乘个
所以最后的答案里面,肯定有一部分是属于n!的阶乘的
即使是傻瓜解法,也必须把这一步的原理给弄清楚,才可以继续往下找规律,不然傻瓜解法也救不了你

所以我们把这个答案给拆开了,拆成了n!和一个不知道是什么的数
接下来跟初中高中找规律是一样的,我们不从原理出发,只从式子本身出发,很容易发现一个规律。规律就在后面的代码里
不必多说了,毕竟这个原理我也说不清楚,只能用我这种笨方法来写
比赛的时候,如果要打表解决的话,注意的就是
别打错了...数组别开小了
其他的没什么好说的

#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
const int N = 1e6+100;
const int mod = 998244353;

//ll factorial(ll a){
//    ll num=1;
//    for (ll i = 1; i <= a;i++)
//       num =(num * i) % mod;
//    return num;
//}

ll a[N];//这里储存之前的所有值,神秘递推式

int main(){
    ll n;
    cin >> n;
    a[1] = 1;
    ll fact = 1;
    for (ll i =2; i <= n;i++){
        fact = fact * i % mod;
        a[i] = (i * (a[i - 1] - 1) + fact) % mod;
    }

    cout << a[n];

    system("pause");
    return 0;
}

对于这个代码我还有个疑问,为什么我写的factorial函数通过不了呢?
输入1000000之后直接RE了,不输出数据
留待以后去解决;

其他的题解实在是看不懂,大家的思路都跟着官方题解走,但是又解释不清楚;
整篇题解的思路来自这个博主:hyacinthLJ
感谢!!万分感谢!!!

原文地址:https://www.cnblogs.com/guaguastandup/p/10353971.html

时间: 2024-11-05 13:33:56

codeforces Goodbye2018 C. New Year and the Permutation Concatenation 傻瓜解法找规律+打表的相关文章

51NOD 1491 黄金系统 &amp;&amp; Codeforces 458 A. Golden System(斐波那契数列 + 找规律)

传送门 q = 5√+12在黄金系统下面a0a1...an等于 ∑ni=0ai?qn?i,其中ai 是 0 或者 1. 现在给出两个黄金系统下面的数字,请比较他们的大小. Input 单组测试数据. 第一行有一个字符串 a . 第二行有一个字符串 b . 他们都是非空串,可能有前导 0,并且只有 0 和 1组成,长度不超过 100000. Output 如果 a>b,输出 >: 如果 a= b,输出 =: 如果 a<b,输出 <: Input示例 00100 11 Output示例

Codeforces Round #275 (Div. 1)A. Diverse Permutation 构造

Codeforces Round #275 (Div. 1)A. Diverse Permutation Time Limit: 1 Sec  Memory Limit: 256 MB 题目连接 http://codeforces.com/contest/482/problem/A Description Permutation p is an ordered set of integers p1,   p2,   ...,   pn, consisting of n distinct posi

Codeforces Round #275 (Div. 2) C - Diverse Permutation (构造)

题目链接:Codeforces Round #275 (Div. 2) C - Diverse Permutation 题意:一串排列1~n.求一个序列其中相邻两项差的绝对值的个数(指绝对值不同的个数)为k个.求序列. 思路:1~k+1.构造序列前段,之后直接输出剩下的数.前面的构造可以根据,两项差的绝对值为1~k构造. AC代码: #include <stdio.h> #include <string.h> int ans[200010]; bool vis[100010]; i

Codeforces Gym 100114 A. Hanoi tower 找规律

A. Hanoi tower Time Limit: 1 Sec Memory Limit: 256 MB 题目连接 http://codeforces.com/gym/100114 Description you the conditions of this task. There are 3 pivots: A, B, C. Initially, n disks of different diameter are placed on the pivot A: the smallest dis

Codeforces 57C Array dp暴力找规律

题目链接:点击打开链接 先是计算非递增的方案, 若非递增的方案数为x, 则非递减的方案数也是x 答案就是 2*x - n 只需求得x即可. 可以先写个n3的dp,然后发现规律是 C(n-1, 2*n-1) 然后套个逆元即可. #include<iostream> #include<cstdio> #include<vector> #include<string.h> using namespace std; #define ll long long #def

Codeforces 837E Vasya&#39;s Function 数论 找规律

题意:定义F(a,0) = 0,F(a,b) = 1 + F(a,b - GCD(a,b).给定 x 和 y (<=1e12)求F(x,y). 题解:a=A*GCD(a,b) b=B*GCD(a,b),那么b-GCD(a,b) = (B-1)*GCD(a,b),如果此时A和B-1依然互质,那么GCD不变下一次还是要执行b-GCD(a,b).那么GCD什么时候才会变化呢?就是说找到一个最小的S,使得(B-S)%T=0其中T是a的任意一个因子.变形得到:B%T=S于是我们知道S=min(B%T).也

找规律/贪心 Codeforces Round #310 (Div. 2) A. Case of the Zeros and Ones

题目传送门 1 /* 2 找规律/贪心:ans = n - 01匹配的总数,水 3 */ 4 #include <cstdio> 5 #include <iostream> 6 #include <algorithm> 7 #include <cstring> 8 #include <cmath> 9 using namespace std; 10 11 const int MAXN = 2e5 + 10; 12 const int INF =

找规律 Codeforces Round #309 (Div. 2) A. Kyoya and Photobooks

题目传送门 1 /* 2 找规律,水 3 */ 4 #include <cstdio> 5 #include <iostream> 6 #include <algorithm> 7 #include <cstring> 8 #include <cmath> 9 using namespace std; 10 11 const int MAXN = 1e4 + 10; 12 const int INF = 0x3f3f3f3f; 13 char s

Codeforces:Diverse Permutation(找规律)

***********************************声明******************************* 原创作品,出自 "晓风残月xj" 博客,欢迎转载,转载时请务必注明出处(http://blog.csdn.net/xiaofengcanyuexj). 由于各种原因,可能存在诸多不足,欢迎斧正! ******************************************************************* time limit